/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive;

/**
 * Notifier for starting and termination of a process.
 */
public interface StartingAndTerminationNotifier<T> {

	/**
	 * Notify the starting of the given process.
	 * @param process the process that starts.
	 */
	public void notifyStarting(T process);
	
	/**
	 * Notify the termination of the given process.
	 * @param process the process that terminates.
	 */
	public void notifyTermination(T process);
}
