/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.ball;

import org.xmloperator.reactive.Message;
import org.xmloperator.reactive.SimpleMessage;
import org.xmloperator.reactive.agent.Cell;

/**
 * This Cell plays to pass each received ball to the next player.
 * It aims to test Cell arrays.
 */
class BallPlayerCell extends Cell<BallPlayerCellArray> {
	
	BallPlayerCell(BallPlayerCellArray cellArray) {
		super(cellArray);
	}

	//////////////////////
	// Cell implementation
	//////////////////////

	/**
	 * Resends the ball to the new destination.
	 */
	public void reactToMessage(Message message) {
		int cellCount = this.cellArray.getCellCount();
		int previousCellNumber = (this.cellNumber + cellCount - 1) % cellCount;
		int nextCellNumber = (this.cellNumber + 1) % cellCount;
		SimpleMessage ballMessage = (SimpleMessage) message;
		int senderCellNumber = ((Integer)ballMessage.getObject()).intValue();
		if (senderCellNumber == previousCellNumber)
			this.cellArray.passBall(this.cellNumber, nextCellNumber);
		else if (senderCellNumber == nextCellNumber)
			this.cellArray.passBall(this.cellNumber, previousCellNumber);
		else
			throw new IllegalStateException();
	}
}
