/*
 * Copyright (c) 2008, 2011 The_xmloperator_project. All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land;

/**
 * Energy of an Agent.
 * An agent stores energy with a maximum limit.
 * An Agent obtains energy from some stations.
 * An Agent can give a part (or the totality) of its energy to another one of its family.
 * With no more energy, an agent dies.
 */
public interface AgentEnergy {

	/**
	 * @return the current energy of the Agent.
	 */
	public int getCurrentEnergy();
	
	/**
	 * Adds the given energy to the Agent.
	 * @param energy a positive or negative quantity.
	 */
	public void addEnergy(int energy);
}
