/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land;

/**
 * Navigation strategy in a graph for an Agent.
 * The NavigationStrategy of an Agent controls its movements.
 */
public interface NavigationStrategy {

	/**
	 * Proposes a new location.
	 * 
	 * @param stationIndex
	 *            a current location.
	 * @param visitMemory
	 *            a VisitMemory.
	 * @return the index of the new location Station.
	 */
	public int nextStationIndex(int stationIndex, VisitMemory visitMemory);

	/**
	 * Returns a NavigationStrategy that is almost the clone of this one.
	 * 
	 * @param seed
	 *            a seed for a possible random number generator.
	 * @return a NavigationStrategy that is almost the clone of this one.
	 */
	public NavigationStrategy almostClone(long seed);
}
