/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.action;

import org.xmloperator.reactive.demo.land.AgentEnergy;
import org.xmloperator.reactive.demo.land.LandBoard;

import org.xmloperator.reactive.impl.ActionImpl;

/**
 * Action of adding or removing some energy to an Agent..
 */
public final class AgentEnergyAction extends ActionImpl {
	private final LandBoard landBoard;
	private final AgentEnergy agentEnergy;
	private final int energy;
	
	public AgentEnergyAction(LandBoard landBoard, AgentEnergy agentEnergy,
			int energy) {
		if (landBoard == null || agentEnergy == null)
			throw new IllegalArgumentException();
		this.landBoard = landBoard;
		this.agentEnergy = agentEnergy;
		this.energy = energy;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public void execute(long permissionKey) {
		super.execute(permissionKey);
		this.landBoard.agentEnergyChange(permissionKey, this.agentEnergy,
				this.energy);
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.agentEnergy.toString() + ((this.energy >= 0) ? "+" : "")
				+ this.energy;
	}
}
