/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.action;

import org.xmloperator.reactive.demo.land.AgentBody;
import org.xmloperator.reactive.demo.land.LandBoard;

import org.xmloperator.reactive.impl.ActionImpl;

/**
 * Action in an AgentFamily.
 */
public final class AgentFamilyAction extends ActionImpl {
	private final LandBoard landBoard;
	private final AgentBody agentBody;
	private final boolean isBirth;
	
	public AgentFamilyAction(LandBoard landBoard, AgentBody agentBody,
			boolean isBirth) {
		if (landBoard == null || agentBody == null)
			throw new IllegalArgumentException();
		this.landBoard = landBoard;
		this.agentBody = agentBody;
		this.isBirth = isBirth;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public void execute(long permissionKey) {
		super.execute(permissionKey);
		if (this.isBirth)
			this.landBoard.agentAppear(permissionKey, this.agentBody);
		else
			this.landBoard.agentTerminate(permissionKey, this.agentBody);
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.agentBody.toString() + (this.isBirth ? " creation" : " done");
	}
}
