/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.action;

import org.xmloperator.reactive.demo.land.AgentLocation;
import org.xmloperator.reactive.demo.land.LandBoard;
import org.xmloperator.reactive.impl.ActionImpl;

/**
 * Action of an Agent that quits any location.
 */
public final class AgentQuitLocationAction extends ActionImpl {
	private final LandBoard landBoard;
	private final AgentLocation agentLocation;
	
	public AgentQuitLocationAction(LandBoard landBoard, AgentLocation agentLocation) {
		if (landBoard == null || agentLocation == null)
			throw new IllegalArgumentException();
		this.landBoard = landBoard;
		this.agentLocation = agentLocation;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public void execute(long permissionKey) {
		super.execute(permissionKey);
		this.landBoard.agentQuit(permissionKey, this.agentLocation);
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.agentLocation.getAgentBody() + ".quit."
				+ this.agentLocation.getCurrentStation();
	}
}
