/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.sphere;

/**
 * Path from a Station to another Station on a sphere of radius 1.
 */
public interface StationPath {

	/**
	 * @return the origin Station of this Path.
	 */
	public Station getOriginStation();

	/**
	 * @return the destination Station of this Path.
	 */
	public Station getDestinationStation();

	/**
	 * @return the pseudo distance (between 0.0 to 4.0) between the two
	 *         stations.
	 */
	public double getPseudoDistance();

	/**
	 * @return the repulsion between the two stations, equals to :
	 *         (1 + cosineCentralAngle) / (1 - cosineCentralAngle).
	 */
	public double getRepulsion();
	
	/**
	 * @return the destination oriented normalized vector in the tangential
	 *         two-dimensional system of the origin Station.
	 */
	public Vector2 getTangent();
}
