/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.sphere.impl;

import java.util.Comparator;

import org.xmloperator.reactive.demo.land.sphere.StationPath;

/**
 * StationPath length comparator.
 */
final class StationPathLengthComparator implements Comparator<StationPath> {
	
	StationPathLengthComparator() {
	}

	/////////////////////////////////////////
	// Comparator<StationPath> implementation
	/////////////////////////////////////////
	
	public int compare(StationPath stationPath1, StationPath stationPath2) {
		double length1 = stationPath1.getPseudoDistance();
		double length2 = stationPath2.getPseudoDistance();
		return 
			length1 < length2 ? -1 :
			length1 > length2 ? +1 :
			0;
	}
}
