/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.market.action;

import org.xmloperator.reactive.demo.market.Proposal;
import org.xmloperator.reactive.demo.market.Resource;
import org.xmloperator.reactive.impl.ActionImpl;

/**
 * Action executed by an operator.
 */
public abstract class OperatorAction extends ActionImpl {
	protected static Resource traceableResource;
	
	public static void setTraceableResource(Resource traceableResource) {
		OperatorAction.traceableResource = traceableResource;
	}
	
	protected final long operatorKey;
	public final Proposal proposal;
	
	OperatorAction(long operatorKey, Proposal proposal) {
		if (proposal == null)
			throw new IllegalArgumentException();
		this.operatorKey = operatorKey;
		this.proposal = proposal;
	}

	////////////////////////
	// Action implementation
	////////////////////////
	
	public final boolean isTraceable() {
		return traceableResource == null
				|| this.proposal.getProposedResource() == traceableResource
				|| this.proposal.getPaymentResource() == traceableResource;
	}
}
