/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.market.impl;

import java.util.Random;

import org.xmloperator.reactive.demo.market.Transformations;
import org.xmloperator.reactive.exception.ReactiveException;
import org.xmloperator.reactive.impl.OperationImpl;

/**
 * Adjusts the Transformations and deduces the Resource unit values.
 */
final class Shake extends OperationImpl {
	private final Transformations transformations;
	private final Random random;
	
	Shake(Transformations transformations, Random random) {
		if (transformations == null || random == null)
			throw new IllegalArgumentException();
		this.transformations = transformations;
		this.random = random;
	}

	///////////////////////////
	// Operation implementation
	///////////////////////////
	
	public final void execute() {
		super.execute();
		TransformationsImpl transformationsI = (TransformationsImpl) this.transformations;
		transformationsI.adjustTransformations(random);
		if (!transformationsI.reduceRelativeProfitsVariance())
			throw new ReactiveException(
					"Some resource unit value cannot be determined.");
	}
}
