/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.syracuse;

import org.xmloperator.reactive.ReactiveCommunity;
import org.xmloperator.reactive.exception.IncorrectKeyException;
import org.xmloperator.reactive.impl.BoardImpl;

/**
 * Board for terminating.
 */
public class ExitBoard extends BoardImpl {
	private boolean isTerminated = false;

	public ExitBoard(ReactiveCommunity community, long permissionKey) {
		super(community, permissionKey);
	}

	/**
	 * Returns true if all the agents must terminate.
	 * @return true if all the agents must terminate.
	 */
	public final boolean isTerminated() {
		return this.isTerminated;
	}
	
	/**
	 * Terminates.
	 * @param permissionKey the authorization key.
	 */
	void terminate(long permissionKey) {
		if (permissionKey != this.boardPermissionKey)
			throw new IncorrectKeyException();
		this.isTerminated = true;
	}
}
