/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.action;

import org.xmloperator.reactive.impl.ActionImpl;

import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ElementBoard;

/**
 * Action applied to an Element.
 */
public abstract class AbstractElementAction extends ActionImpl
		implements ElementAction {

	public final ElementBoard elementBoard;
	public final Element referenceElement;
	
	public AbstractElementAction(ElementBoard elementBoard,
			Element referenceElement) {
		if (elementBoard == null || referenceElement == null)
			throw new IllegalArgumentException();
		this.elementBoard = elementBoard;
		this.referenceElement = referenceElement;
	}
	
	///////////////////////////////
	// ElementAction implementation
	///////////////////////////////
	
	public ElementBoard getElementBoard() {
		return this.elementBoard;
	}

	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.referenceElement.hierarchicalPosition();
	}
}
