/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.impl;

import java.util.List;
import java.util.ArrayList;

import org.xmloperator.reactive.element.RootElement;
import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.Namespace;

/**
 * RootElement implementation.
 */
public class RootElementImpl extends ParentElementImpl implements
		RootElement {
	protected final List<Namespace> namespaceList = new ArrayList<Namespace>();
	
	public RootElementImpl(String namespaceURI, String localName) {
		super(namespaceURI, localName);
		this.namespaceList
				.add(new Namespace(Element.REACTIVE_NAMESPACE, "reac"));
	}

	public RootElementImpl(String namespaceURI, String localName,
			Element[] children) {
		this(namespaceURI, localName);
		if (children != null)
			this.addChildren(children);
	}
	
	/////////////////////////////
	// RootElement implementation
	/////////////////////////////
	
	public int namespaceCount() {
		return this.namespaceList.size();
	}
	
	public Namespace getNamespace(int index) {
		return (Namespace)this.namespaceList.get(index);
	}
	
	public void addNamespace(Namespace namespace) {
		this.namespaceList.add(namespace);
	}
}
