/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.impl;

/**
 * SimpleCertifiedMessage implementation.
 */
import org.xmloperator.reactive.DoubleMessage;

/**
 * DoubleMessage implementation.
 */
public class DoubleMessageImpl extends MessageImpl implements
		DoubleMessage {
	protected final Object object1;
	protected final Object object2;
	
	public DoubleMessageImpl(Object object1, Object object2) {
		super();
		this.object1 = object1;
		this.object2 = object2;
	}

	public DoubleMessageImpl(int destinationCellNumber, Object object1,
			Object object2) {
		super(destinationCellNumber);
		this.object1 = object1;
		this.object2 = object2;
	}

	///////////////////////////////
	// DoubleMessage implementation
	///////////////////////////////

	public final Object getObject1() {
		return this.object1;
	}

	public final Object getObject2() {
		return this.object2;
	}

	/////////////////////////
	// Message implementation
	/////////////////////////
	
	public boolean isDoubleMessage() {
		return true;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append('(');
		sb.append(this.object1);
		sb.append(',');
		sb.append(this.object2);
		sb.append(')');
		return sb.toString();
	}
}
