/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.impl;

/**
 * SimpleCertifiedMessage implementation.
 */
import org.xmloperator.reactive.SimpleMessage;

/**
 * Simple message implementation.
 */
public class SimpleMessageImpl extends MessageImpl implements
		SimpleMessage {
	protected final Object object;
	
	public SimpleMessageImpl(Object object) {
		super();
		this.object = object;
	}

	public SimpleMessageImpl(int destinationCellNumber, Object object) {
		super(destinationCellNumber);
		this.object = object;
	}

	///////////////////////////////
	// SimpleMessage implementation
	///////////////////////////////

	public final Object getObject() {
		return this.object;
	}

	/////////////////////////
	// Message implementation
	/////////////////////////
	
	public boolean isSimpleMessage() {
		return true;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append('(');
		sb.append(this.object);
		sb.append(')');
		return sb.toString();
	}
}
